<template>
  <v-container>
    <h2 class="my-3">Gestion des objets</h2>
    <h3>La liste des objets</h3>
    <br>
    <table class="center" border="1"> <!-- Récupération des objets ajoutés dans la base -->
      <tr>
        <th>UUID</th>
        <th>Nom</th>
        <th>Description</th>
        <th>Catégorie</th>
        <th>Date création</th>
        <th>Emplacement musée</th>
        <th>Objet visible</th>
        <th>Traduction</th>
      </tr>
      <tr v-for="object in objets" :key="object.uuidobjet">
        <td>{{ object.uuidobjet }}</td>
        <td>{{ object.nomobjet }}</td>
        <td>{{ object.descriptionobjet }}</td>
        <td>{{ object.libellecategorie }}</td>
        <td>{{ object.datecreation }}</td>
        <td>{{ object.emplacementmusee }}</td>
        <td>{{ object.visibleobjet }}</td>
        <td>{{ object.libellelangue }}</td>
      </tr>
    </table>
    <br>
    <h3>Ajouter un objet</h3> <!-- Ajouter un objet -->
      <v-layout column wrap>
        <v-layout row wrap>
          <v-flex md4>
            <v-select label="Choisir une langue" v-model="choixlangue" v-bind:items="langues" item-text="libellelangue" item-value="isolangue">
            </v-select>
          </v-flex>
          <v-flex md4 offset-md1>
            <v-text-field v-model="libelleobjet" label="Libellé de l'objet"></v-text-field>
          </v-flex>
        </v-layout>
        <v-layout row wrap>
          <v-flex md4>
            <v-text-field v-model="descriptionobjet" label="Description de l'objet"></v-text-field>
          </v-flex>
          <v-flex md4 offset-md1>
            <v-text-field v-model="fabricationobjet" label="Date de fabrication"></v-text-field>
          </v-flex>
          </v-layout>
          <v-layout row>
          <v-flex md4>
            <v-text-field v-model="emplacementmusee" label="Emplacement dans le musée"></v-text-field>
          </v-flex>
          <v-flex md4 offset-md1>
            <v-select label="Choisir une catégorie" v-model="choixcategorie" v-bind:items="categories" item-text="libellecategorie" item-value="uuidcategorie">
            </v-select>
          </v-flex>
          </v-layout>
          <v-layout row>
          <v-flex md4>
            <v-select label="Choisir un auteur" v-model="choixauteur">
            </v-select>
          </v-flex>
          <v-flex md4 offset-md1>
            <form method="POST" enctype="multipart/form-data">
              <p>Sélectionner une image</p>
              <input id="file" type="file" name="file" @change="uploadFile" accept="image/*">
            </form>
          </v-flex>
        </v-layout>
      </v-layout>
      <v-btn outline color="light-green darken-1" v-on:click="addObjet()">Ajouter</v-btn>
      <div v-if="imageData.length > 0">
        <img class="preview" :src="imageData">
      </div>
    <br>
    <h3>Modifier un objet</h3>
    <v-layout row wrap>
      <v-flex md4>
        <v-select label="Choisir un objet" v-model="choixObjet" v-bind:items="objets" item-text="nomobjet" item-value="uuidobjet">
        </v-select>
      </v-flex>
      <v-flex md4 offset-md1>
        <v-btn outline color="primary" v-on:click="idObjet()">Choisir</v-btn>
      </v-flex>
    </v-layout>
    <div v-for="objet in modifierObjet" :key="objet.uuidobjet">
      <v-layout row wrap>
      <v-flex md4>
        <v-text-field label="Modifier le libellé" v-model="modifierLibelle"></v-text-field>
      </v-flex>
      <v-flex md4 offset-md1>
        <v-text-field label="Modifier la description" v-model="modifierDescription"></v-text-field>
      </v-flex>
      </v-layout>
      <v-btn outline color="warning" v-on:click="putObjet()">Appliquer</v-btn>
    </div>
    <br>
    <h3>Supprimer un objet</h3>
    <v-layout row wrap>
      <v-flex md4>
        <v-select label="Supprimer un objet" v-model="supprimeObjet" v-bind:items="objets" item-text="nomobjet" item-value="uuidobjet">
        </v-select>
      </v-flex>
      <v-flex md4 offset-md1>
        <v-btn outline color="error" @click.native.stop="dialog = true">Supprimer</v-btn>
      </v-flex>
    </v-layout>
    <v-dialog v-model="dialog" max-width="350">
      <v-card>
        <v-card-title class="headline">Confirmation de suppression</v-card-title>
        <v-card-text>Etes-vous sûr de vouloir supprimer l'objet ?</v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn outline color="green darken-1" flat="flat" @click.native="dialog = false">Annuler</v-btn>
          <v-btn outline color="error" flat="flat" v-on:click="deleteObjet()" @click.native="dialog = false">Supprimer</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>

<script>
export default {
  data () {
    return {
      objets: [],
      categories: [],
      langues: [],
      libelleobjet: '',
      descriptionobjet: '',
      fabricationobjet: '',
      emplacementmusee: '',
      choixlangue: '',
      choixcategorie: '',
      supprimeObjet: '',
      choixObjet: '',
      modifierObjet: '',
      modifierLibelle: '',
      modifierDescription: '',
      choixauteur: '',
      choixvitrine: '',
      dialog: false,
      imageData: ''
    }
  },
  mounted: function () {
    this.getObjets()
  },
  methods: {
    getObjets: function () {
      this.$http.get('http://localhost:3000/objet')
      .then(response => {
        this.objets = response.data
        console.log('GET OBJET', response.data)
      })
      this.$http.get('http://localhost:3000/categorie')
      .then(response => {
        this.categories = response.data
      })
      this.$http.get('http://localhost:3000/langue')
      .then(response => {
        this.langues = response.data
      })
    },
    addObjet: function () {
      const objet = {
        nom: this.libelleobjet,
        description: this.descriptionobjet,
        emplacement: this.emplacementmusee,
        fabrication: this.fabricationobjet,
        categorie: this.choixcategorie,
        langue: this.choixlangue
      }
      this.$http.post('http://localhost:3000/objet', objet)
        .then(response => {
          console.log('POST : ', response)
          this.getObjets()
        })
    },
    idObjet: function () {
      this.$http.get('http://localhost:3000/objet/' + this.choixObjet)
      .then(response => {
        this.modifierObjet = response.body
        console.log('GET OBJET ID', response.data)
      })
    },
    putObjet: function () {
      console.log('PUT ID :', this.modifierLibelle, this.modifierDescription)
      const modifObjet = {
        libelle: this.modifierLibelle,
        description: this.modifierDescription
      }
      this.$http.put('http://localhost:3000/objet/' + this.choixObjet, modifObjet)
      .then(response => {
        console.log('PUT OBJET :', response)
        this.getObjets()
      })
    },
    deleteObjet: function () {
      if (this.supprimeObjet === '') {
        alert('Veillez choisir un objet avant de supprimer')
      } else {
        this.$http.delete('http://localhost:3000/objet/' + this.supprimeObjet)
          .then(response => {
            console.log('DELETE :', response)
            this.getObjets()
          })
          .catch(response => {
            console.log('ERROR : ', response.status)
          })
      }
    },
    uploadFile: function (event) {
      var input = event.target
      if (input.files && input.files[0]) {
        var reader = new FileReader()
        reader.onload = (e) => {
          this.imageData = e.target.result
        }
        reader.readAsDataURL(input.files[0])
      }
      console.log('UPLOAD : ', input.files)
      const formdata = new FormData(input.files[0])
      formdata.append('file', input.files[0])
      console.log('UPLOAD formdata : ', formdata)
      this.$http.post('http://localhost:3000/upload', {formdata}, {
        progress (e) {
          if (e.lengthComputable) {
            console.log(e.loaded / e.total * 100 + ' %')
          }
        }
      })
    }
  }
}
</script>

<style>
.center{
  text-align: center
}

img.preview {
    width: 200px;
    padding: 5px;
}
</style>
